#!/usr/local/bin/python2.7

import time
from math import sqrt

def is_triangular(number):
  """
  Given that triangular numbers satisfy t_n = (1/2) n * (n + 1), 
  we can check if a given number is triangular by determining if
  n ** 2 + n - 2 t_n = 0 has a solution. Using the quadratic equation,
  and assuming the solution n > 0, we just need to check if
  (-1 + sqrt(1 + 8 t_n) ) / 2 is an integer.
  """
  return ((-1.0 + sqrt(1.0 + 8.0 * number)) / 2.0).is_integer()
 
def is_pentagonal(number):
  """
  This is solved similarly to that which is outlined above.
  """
  return ((1.0 + sqrt(1.0 + 24.0 * number)) / 6.0).is_integer()

def is_hexagonal(number):
  """
  This is solved similarly to that which is outlined above.
  """
  return ((1.0 + sqrt(1.0 + 8.0 * number)) / 4.0).is_integer()

def triangular(n):
  """
  Returns the nth triangular number
  """
  return ((n ** 2 + n ) / 2)
  
def euler45():
  """"
  Triangle, pentagonal, and hexagonal numbers are generated by the 
  following formulae:
  
  Triangle    Tn = n(n+1)/2
  Pentagonal  Pn = n(3n-1)/2
  Hexagonal   Hn = n(2n - 1)
  
  It can be verified that T285 = P165 = H143 = 40755.

  Find the next triangle number that is also pentagonal and hexagonal.
  """
  n = 286
  candidate = triangular(n)
  while True:
    if is_pentagonal(candidate) and is_hexagonal(candidate):
      return candidate
    n += 1
    candidate = triangular(n)

#boilerplate code to run
def main():
  start = time.time()
  print('The solution is: %d' % euler45())
  elapsed = (time.time() - start)
  print('Time elapsed: ' + str(elapsed))

if __name__ == '__main__':
  main()
